/*
Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Esame del 04/02/2008
compito i2+i3
Tempo a disposizione: 2h 45 min

Scrivere un programma per la gestione dei dipendenti e delle attivit di un'azienda.
I dipendenti sono caratterizzati dalle seguenti informazioni: Nome, Cognome, numero di matricola, data di assunzione, tipo di qualifica.
I dipendenti sono inseriti in una tabella allocata dinamicamente avente 4 righe, una  per ogni tipo di qualifica.
Ai dipendenti pu essere assegnato un compito da svolgere un certo giorno della settimana.
Ogni compito  caratterizzato dalle seguenti informazioni: numero di matricola, giorno della settimana, codice attivit. I compiti vengono inseriti in un vettore di 5 liste, una per ogni giorno lavorativo della settimana.
Ogni lista  ordinata rispetto al codice attivit.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento nella tabella di un nuovo dipendente;
2.Visualizzazione dei dipendenti con un tipo di qualifica;
3.Inserimento ordinato nel vettore di liste di un nuovo compito;
4.Visualizzazione dei compiti relativi a un certo giorno.
5.Salvataggio su file del contenuto della tabella.


Allavvio del programma i dipendenti precedentemente salvati su file devono essere letti e copiati nella tabella mediante una funzione di inizializzazione della tabella.
 Liberare la memoria allocata dinamicamente.

*/
#include <stdio.h>
#include <stdlib.h>

typedef struct{
	int matricola,codice;
	int giorno;
}compito;


struct atomo{
	compito dato;
	struct atomo *next;
};

typedef struct{
	char nome[30],cognome[30],data[11];
	int matricola,tipo;
}dipendente;



void ins_tabella(dipendente *T[4], int *N);
void vis_tabella(dipendente *T[4], int *N);
void inizializza_tabella(dipendente *T[4], int *N);
void salva_tabella(dipendente *T[4], int *N);
void leggi(compito *s);
void ins_ordinato(struct atomo *tl[5]);
void vis_lista(struct atomo *tl[5]);
void libera_liste(struct atomo **tl);
void menu();

main() {
	struct atomo *LC[5];
	compito s;
	dipendente *TD[4];
	int N[4],opz,i,tessera;


	for(i=0;i<4;i++)
		{	TD[i]=NULL;
			N[i]=0;
		}

	for(i=0;i<5;i++)
		LC[i]=NULL;

	inizializza_tabella(TD,N);
	do{	menu();
		scanf("%d",&opz);
		switch(opz){
			case 1: ins_tabella(TD,N);
					break;
			case 2: vis_tabella(TD,N);
					break;
			case 3: ins_ordinato(LC);
					break;
			case 4: vis_lista(LC);
					break;
			case 5: salva_tabella(TD,N);
					break;

			default:;
		}
	}while(opz!=0);

	for(i=0;i<5;i++)
		libera_liste(&LC[i]);
	for(i=0;i<4;i++)
		free(TD[i]);
}


void leggi(compito *s)
{
	printf("Inserisci la matricola: ");
	scanf("%d",&s->matricola);
	printf("Inserisci il codice attivita': ");
	scanf("%d",&s->codice);
	printf("Inserisci il giorno della settimana (0,..,4): ");
	scanf("%d",&s->giorno);
}

void ins_ordinato(struct atomo *TL[5])

{
    compito s;
	struct atomo *aux, *l1,*l2;
    int g;

	leggi(&s);

	aux=malloc(sizeof(struct atomo));
	if(aux==NULL) return;
	aux->dato=s;

	g=s.giorno;
	if(TL[g]==NULL || s.codice<TL[g]->dato.codice)
		{	aux->next=TL[g];
			TL[g]=aux;
			return;
		}
	l2=TL[g];
	l1=l2->next;

	while(l1!=NULL)
		{	if(s.codice<l1->dato.codice)
				break;
			else { l2=l1;
					l1=l1->next;
				 }
		}

	l2->next=aux;
	aux->next=l1;
}



void vis_lista(struct atomo *tl[5])
{
	int giorno;
	struct atomo *aux;

	printf("Inserisci il giorno della settimana (0,..,4)\n");
	scanf("%d",&giorno);

	aux=tl[giorno];
	while(aux!=NULL)
		{	printf("Matricola %d\n",aux->dato.matricola);
			printf("Codice attivita': %d\n",aux->dato.codice);
			aux=aux->next;
		}


}




void ins_tabella(dipendente *T[4], int *N)
{
	int p,i,tipo;
	struct atomo *aux;
	dipendente d,*R;

	printf("\nNome: ");
	scanf("%s", d.nome);
	printf("\nCognome: ");
	scanf("%s", d.cognome);
	printf("\nMatricola: ");
	scanf("%d", &d.matricola);
	printf("\nTipo di qualifica: ");
	scanf("%d", &d.tipo);
	printf("\nData: ");
	scanf("%s", d.data);

    tipo=d.tipo;
	R=realloc(T[tipo],sizeof(dipendente)*(N[tipo]+1));
	if(R==NULL) return;
    T[tipo]=R;

	T[tipo][N[tipo]]=d;
	N[tipo]++;
}

void inizializza_tabella(dipendente *T[4], int *N)
{
	FILE *pf;

	int tipo;
	struct atomo *aux;
	dipendente d,*R;


	pf=fopen("dip.dat","rb");
	if(pf)
		{  while(fread(&d,sizeof(dipendente),1,pf))
	          {  	tipo=d.tipo;
					R=realloc(T[tipo],sizeof(dipendente)*(N[tipo]+1));
					if(R==NULL) return;
    				T[tipo]=R;

					T[tipo][N[tipo]]=d;
					N[tipo]++;
			   }
			fclose(pf);
	}


}

void salva_tabella(dipendente *T[4], int *N)
{

	FILE *pf;
	int tipo;
	pf=fopen("dip.dat","wb");
	if(pf)
	   {  for(tipo=0;tipo<4;tipo++)
   			fwrite(T[tipo],sizeof(dipendente),N[tipo],pf);
		  fclose(pf);
	}
	else printf("Errore");
}




void vis_tabella(dipendente *T[4], int *N)
{
	int tipo,i;
	printf("Inserisci il tipo di qualifica\n");
	scanf("%d",&tipo);

	for(i=0;i<N[tipo];i++)
		{	printf("Nome %s\n",T[tipo][i].nome);
			printf("Cognome %s\n",T[tipo][i].cognome);
			printf("Mtricola %d\n\n",T[tipo][i].matricola);
		}
}

void libera_liste(struct atomo **tl)
{
	struct atomo *aux;
	while(*tl!=NULL)
		{	aux=*tl;
			*tl=aux->next;
			free(aux);
		}
}
void menu(){
	printf("Scegli tra\n");
	printf("1) Inserimento di una dipendente\n");
	printf("2) Visualizza una riga");
	printf("3) Inserimento in lista di un compito\n");
	printf("4) Visualizza una lista\n");
	printf("5) Salva su file\n");
	printf("0) Esci\n\n");
}
